

var map;

function centerMap(){
	map.setView([48.12049671846783, -1.5810012817382815], 12);
	return false;
}

window.onload = function(){

	// draggable layers for dev process
	var dragMode = false;

	map = L.map('map');

	var osm = L.tileLayer(
		'https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', // l'url des tuiles openstreetmap
		{
		    attribution: '&copy; <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors',
		    minZoom: 11,
		    maxZoom: 16
		}
	).addTo(map);

	centerMap();

	// dev tools
	map.on('zoomend', function(){
		console.log("zoom", map.getZoom());
	});
	if(!dragMode){
		map.on('click', function(e){
			// console.log( '['+e.latlng.lat +', '+ e.latlng.lng+']');
			console.log( e.latlng.lat +', '+ e.latlng.lng);
		});
	}



	var icon_palm = L.icon({
		iconUrl: 'img/palm.png',
		iconAnchor: [16, 32], 
		popupAnchor: [0, -32]
	});
		// et une 2ème icône...
	var icon_palm2 = L.icon({
		iconUrl: 'img/palm2.png',
		iconAnchor: [15, 32],
		popupAnchor: [0, -32]
	});

	L.marker([48.11935075227587, -1.6757583618164065], {
		icon: icon_palm	,
		// interactive: false
	}).bindPopup("This is Leaflet <br>palm marker.").addTo(map);

	L.marker([48.095967461896834, -1.6232299804687502], {
		icon: icon_palm	,
		// interactive: false
	}).bindPopup("Another palm !").addTo(map);

	L.marker([48.11470932778303, -1.5647792816162112], {
		icon: icon_palm2	,
		// interactive: false
	}).bindPopup("Just a Leaflet marker, <br>with a custom icon.").addTo(map);

	L.marker([48.18417221916199, -1.5731048583984377], {
		icon: L.icon({
			iconUrl: 'img/flag.png',
			iconAnchor: [16, 32], 
			popupAnchor: [0, -32]
		}),
		// interactive: false
	}).bindPopup("Just a Leaflet marker, <br>with a custom icon.").addTo(map);


	// image overlay
	/*L.imageOverlay(
		'img/smb3-map.png',
		[
			[48.11875627224386, -1.7012715339660647], // point NO
			[48.11767473068865, -1.6985464096069338] // point SE
		],
		{ interactive: false}
	).addTo(map);*/


	// HTML Overlay

	var gp1 = $('.groupe1 .bloc').htmlOverlay().addTo(map);
	var gp2 = $('.groupe2 .bloc').htmlOverlay().addTo(map);
	var gp3 = $('.groupe3 .bloc').htmlOverlay().addTo(map);
	var gp4 = $('.groupe4 .bloc').htmlOverlay().addTo(map);


	// dev tools, for dragging layers visually
	// and getting readable coordinates in the dev console...
	var id, pos;
	function draggableGroup(group){

		// ok, first set all the layers interactive for it to be clickable
		for(var key in group._layers){
			group._layers[key].options.interactive = true;
		}
		// then remove and add again to the map
		// for the interactive setting to be effective
		group.remove();
		group.addTo(map);

		// ready to get every layer draggable...
		for(var key in group._layers){

			(function(){

				var obj = group._layers[key];
				// console.log("obj", obj);

				obj.on('mousedown', function (e) {
					console.log("mousedown !");
					// console.log(obj._code);

					id = $(obj._code).attr('id');

					// stop dragging the map
					map.dragging.disable();

					map.on('mousemove', function (e) {
						obj.setLatLng(e.latlng);
					});
				});

			})();	
		}
		if(!window.mouseup_listener_added){
			console.log("yeah", );
			window.mouseup_listener_added = true;
			map.on('mouseup',function(e){
				map.removeEventListener('mousemove');
				// restart dragging the map
				map.dragging.enable();

				if(id){ 
					console.log(id);
					console.log(e.latlng.lat +', '+ e.latlng.lng);
				}
			});
		}			
	}
	if(dragMode){
		draggableGroup(gp1);
		draggableGroup(gp2);
		draggableGroup(gp3);
		draggableGroup(gp4);
	}


	// layers controls
	L.control.layers({}, 
		{
			"Open Street Map" : osm,
			"LayerGroup 1":gp1, 
			"LayerGroup 2":gp2, 
			"LayerGroup 3":gp3, 
			"LayerGroup 4":gp4
		},
		{
			position: "topright", // topleft', 'topright', 'bottomleft' or 'bottomright'
			collapsed: false
		}).addTo(map);



	//  saisie du code html à la main
	/*L.htmlOverlay(
		'<div style="background:yellow;"><h1>Oh!</h1></div>',
		[48.11825489819488, -1.7042487859725954],
		{ zoom: 17 }
	).addTo(map);

	L.htmlOverlay(
		'<div style="background:yellow;"><p>&nbsp;Eh&nbsp;</p></div>',
		[48.12002401051115, -1.7041897773742676],
		{ zoom: 17 }
	).addTo(map);


	// injection d'un bloc html de la page web, via jQuery
	$('#elmt1').htmlOverlay(
		[48.11833010461414, -1.7030149698257449], 
		{ zoom: 18 }
	).addTo(map);


	// injection d'un bloc html de la page web, via jQuery
	// les coords et niveaux de zoom sont indiqués dans le code html
	$('#elmt2').htmlOverlay().addTo(map);*/

};